#!/usr/bin/perl
# -*-Perl-*-
# Last changed Time-stamp: <2002-04-04 18:02:51 ivo>
# reads the output from alidot or pf_rali and edits an xrna .ss file to
# include circles around bases with complentary mutations and gray letter
# for bases that are incompatible in some sequences. The original .ss file
# is renamed to .ss.bak (does not read from stdin!)
# offset =  start_of_sequence-1

sub usage {
    die "Usage: $0 aln.out xrna.ss offset\n";
}

open(ALIOUT, "<$ARGV[0]") || usage();
rename($ARGV[1], "$ARGV[1].bak");   # backup the xrna.ss file
open(XRNA, "<$ARGV[1].bak") || usage();
open(NXRNA, ">$ARGV[1]") || die("can't append to .ss file");

$offset = $ARGV[2];

while (<XRNA>) {
    print NXRNA $_ unless (/#!s /); # strip spourious color statments
    next unless (/^(\d+) ([ACGU]) (\S+) (\S+) (\d+) (\d+)$/);
    chomp;
    $seq .= $2;
    next if ($6==0);
    $pair[$1] = $6;
    $x[$1] = $3; $y[$1]=$4;
}
printf NXRNA "1-%d#!s 8 0 0\n", length($seq);

$_ = <ALIOUT>;
$_ = <ALIOUT>; # skip two lines
while (<ALIOUT>) {
    chomp;
    s/\*$//;  # remove trailing '*'
    ($i, $j, $nc, $p, $s, @pp) = split;
    next unless ($i>0 && $j>0);
    $i -= $offset; $j -= $offset;
    next unless ($pair[$i]==$j);

    $ppair = shift @pp; # first element of @pp
    ($c01,$c02,$dummy) =  split(//,$ppair,3);
    $m1=$m2=0;
    foreach $ppair (@pp) {
	($c1,$c2,$dummy) =  split(//,$ppair,3);
	next if ($c1 eq '-');
	$m1=1 if ($c1 ne $c01);  # first base changes
	$m2=1 if ($c2 ne $c02);  # second base changes
    }
    # draw circles
    print NXRNA "a $x[$i] $y[$i] 0.0 $i 0.0 360.0 4.5 0.5 1 0\n" if ($m1);
    print NXRNA "a $x[$j] $y[$j] 0.0 $j 0.0 360.0 4.5 0.5 1 0\n" if ($m2);
    # use grayscale to imply nocompatible sequences
    if ($nc>0) {
	$gray = "333333";
	$gray = "666666" if ($nc>=2);
	$gray = "999999" if ($nc>=3);
	print NXRNA "$i#!s 8 0 $gray\n";
	print NXRNA "$j#!s 8 0 $gray\n";
    }
}
